拡張コンテキストメニュー

SpreadJSの組み込みコンテキストメニューには、カスタムメニューオプションを追加または削除できます。個々のオプションは、JSONスキーマの定義済みメニューデータに準拠しています。

説明
app.js
index.html
styles.css

menuDataプロパティを、次のように定義できます。

    var openDialog = {
        text: 'Open Dialog',
        name: 'openDialog',
        command: showLoginDialog,
        workArea: 'viewport'
    };
    spread.contextMenu.menuData.push(openDialog);
    function showLoginDialog() {
        // ログインダイアログを表示します。
    }

カスタムメニューオプションを追加または削除するには、spread.contextMenu.menuDataプロパティを使用します。

    $.each(spread.contextMenu.menuData, function (p, v) {
        if (v.name === 'openDialog') { // openDialogはコマンド名です。
            spread.contextMenu.menuData.splice(p, 1)
        }
    });
menuDataプロパティを、次のように定義できます。 カスタムメニューオプションを追加または削除するには、spread.contextMenu.menuDataプロパティを使用します。
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), {sheetCount: 2}); initSpread(spread); }; function initSpread(spread) { initEvents(spread); } function initEvents(spread) { document.getElementById('addFormatCells').onchange = function () { var commandRemoved = false; spread.contextMenu.menuData.forEach(function (item, index) { if (item && item.name === "markWithRedBg") { spread.contextMenu.menuData.splice(index, 1); commandRemoved = true; } }); if (commandRemoved) { return; } var commandManager = spread.commandManager(); var markWithRedBg = { text: "Format Cells", name: "markWithRedBg", command: "markWithRedBg", workArea: "viewport" }; spread.contextMenu.menuData.push(markWithRedBg); var markWithRedBgCommand = { canUndo: false, execute: function () { var style = new GC.Spread.Sheets.Style(); style.name = 'style1'; style.backColor = 'red'; var sheet = spread.getActiveSheet(); sheet.suspendPaint(); var selections = sheet.getSelections(); var selectionIndex = 0, selectionCount = selections.length; for (; selectionIndex < selectionCount; selectionIndex++) { var selection = selections[selectionIndex]; for (var i = selection.row; i < (selection.row + selection.rowCount); i++) { for (var j = selection.col; j < (selection.col + selection.colCount); j++) { sheet.setStyle(i, j, style, GC.Spread.Sheets.SheetArea.viewport); } } } sheet.resumePaint(); } }; commandManager.register("markWithRedBg", markWithRedBgCommand, null, false, false, false, false); }; document.getElementById('addOpenDialog').onchange = function () { var commandRemoved = false; spread.contextMenu.menuData.forEach(function (item, index) { if (item && item.name === "openDialog") { spread.contextMenu.menuData.splice(index, 1); commandRemoved = true; } }); if (commandRemoved) { return; } var openDialog = { text: "Open Dialog", name: "openDialog", command: showLoginDialog, workArea: "viewport" }; spread.contextMenu.menuData.push(openDialog); }; } function showLoginDialog() { if (document.getElementsByClassName('loginBox').length === 0) { var loginBox = document.createElement('div'); loginBox.className = 'loginBox'; loginBox.innerHTML = '<label for="Dialog" class="loginBoxLabel">Dialog:</label>' + '<input type="button" id="okBtn" class="btn-primary button" value="OK">' + '<input type="button" id="cancelBtn" class="btn-primary button" value="Cancel">'; document.body.appendChild(loginBox); document.getElementById('okBtn').onclick = function (){ loginBox.style.display = 'none'; }; document.getElementById('cancelBtn').onclick = function (){ loginBox.style.display = 'none'; }; } var loginBoxEle = document.getElementsByClassName('loginBox')[0]; if (loginBoxEle.style.display === 'none') { loginBoxEle.style.display = 'block'; } }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta name="spreadjs culture" content="ja-jp" /> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets-resources-ja/dist/gc.spread.sheets.resources.ja.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <p>任意のセルを右クリックすると、固有のコンテキストメニューが表示されます。このコンテキストメニューに対し、以下のいずれかのオプションを追加または削除できます。</p> <div id="settingsDiv"> <div class="option-row"> <input id="addFormatCells" type="checkbox" /> <label for="addFormatCells">[セルの書式設定]メニュー項目を追加する</label> </div> <div class="option-row"> <input id="addOpenDialog" type="checkbox" /> <label for="addOpenDialog">[ダイアログを開く]メニュー項目を追加する</label> </div> </div> </div> </div></body> </html>
.option-row { font-size: 14px; padding: 5px; margin-top: 10px; } .buttonStyle{ width:240px; height:30px; } .loginBox { position: absolute; left: 35%; top: 30%; background-color: white; padding: 20px; border: 1px solid #c6c6c6; box-shadow: rgba(0, 0, 0, 0.4) 1px 2px 5px; z-index: 2000; height: 100px; width: 200px; } .loginBoxLabel { display: inline-block; width: 200px; text-align: center; } .button{ width: 30%; margin: 60px 10%; text-align: center; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; margin-top: 10px; } label { margin-bottom: 6px; } input { padding: 4px 6px; } input[type=button] { margin-top: 6px; } p{ padding:2px 10px; background-color:#F4F8EB; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; }

menuDataプロパティを、次のように定義できます。
カスタムメニューオプションを追加または削除するには、spread.contextMenu.menuDataプロパティを使用します。
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="options-row">
<p>任意のセルを右クリックすると、固有のコンテキストメニューが表示されます。このコンテキストメニューに対し、以下のいずれかのオプションを追加または削除できます。</p>
</div>
<div class="options-row">
<input type="checkbox" id="addFormatCell" v-model="addFormatCell">
<label for="addFormatCell">[セルの書式設定]メニュー項目を追加する</label>
</div>
<div class="options-row">
<input type="checkbox" id="addOpenDialog" v-model="addOpenDialog">
<label for="addOpenDialog">[ダイアログを開く]メニュー項目を追加する</label>
</div>
</div>
</template>
<script setup>
import { ref, watch } from "vue";
import "@mescius/spread-sheets-vue";
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
const spreadRef = ref(null);
const addFormatCell = ref(false);
const addOpenDialog = ref(false);
watch(addFormatCell, (value) => {
let spread = spreadRef.value;
let commandRemoved = false;
spread.contextMenu.menuData.forEach(function (item, index) {
if (item && item.name === "markWithRedBg") {
spread.contextMenu.menuData.splice(index, 1);
commandRemoved = true;
}
});
if (commandRemoved) {
return;
}
let commandManager = spread.commandManager();
let markWithRedBg = {
text: "Format Cells",
name: "markWithRedBg",
command: "markWithRedBg",
workArea: "viewport"
};
spread.contextMenu.menuData.push(markWithRedBg);
let markWithRedBgCommand = {
canUndo: false,
execute: function () {
let style = new GC.Spread.Sheets.Style();
style.name = 'style1';
style.backColor = 'red';
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
let selections = sheet.getSelections();
let selectionIndex = 0, selectionCount = selections.length;
for (; selectionIndex < selectionCount; selectionIndex++) {
let selection = selections[selectionIndex];
for (let i = selection.row; i < (selection.row + selection.rowCount); i++) {
for (let j = selection.col; j < (selection.col + selection.colCount); j++) {
sheet.setStyle(i, j, style, GC.Spread.Sheets.SheetArea.viewport);
}
}
}
sheet.resumePaint();
}
};
commandManager.register("markWithRedBg", markWithRedBgCommand, null, false, false, false, false);
});
watch(addOpenDialog, (value) => {
let spread = spreadRef.value;
let commandRemoved = false;
spread.contextMenu.menuData.forEach(function (item, index) {
if (item && item.name === "openDialog") {
spread.contextMenu.menuData.splice(index, 1);
commandRemoved = true;
}
});
if (commandRemoved) {
return;
}
let openDialog = {
text: "Open Dialog",
name: "openDialog",
command: showLoginDialog,
workArea: "viewport"
};
spread.contextMenu.menuData.push(openDialog);
});
let initSpread = function (spread) {
spreadRef.value = spread;
}
function showLoginDialog() {
if (document.getElementsByClassName('loginBox').length === 0) {
var loginBox = document.createElement('div');
loginBox.className = 'loginBox';
loginBox.innerHTML = '<label for="Dialog" class="loginBoxLabel">Dialog:</label>' +
'<input type="button" id="okBtn" class="btn-primary button" value="OK">' +
'<input type="button" id="cancelBtn" class="btn-primary button" value="Cancel">';
document.body.appendChild(loginBox);
document.getElementById('okBtn').onclick = function () {
loginBox.style.display = 'none';
};
document.getElementById('cancelBtn').onclick = function () {
loginBox.style.display = 'none';
};
}
var loginBoxEle = document.getElementsByClassName('loginBox')[0];
if (loginBoxEle.style.display === 'none') {
loginBoxEle.style.display = 'block';
}
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.button {
width: 30%;
margin: 60px 10%;
text-align: center;
}
input {
display: inline-block;
}
input[type="text"] {
width: 200px;
}
input[type="button"] {
margin-top: 6px;
}
label {
margin-bottom: 6px;
}
p {
padding: 2px 10px;
background-color: #F4F8EB;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.desc {
padding: 2px 10px;
background-color: #F4F8EB;
}
.loginBox {
position: absolute;
left: 35%;
top: 30%;
background-color: white;
padding: 20px;
border: 1px solid #c6c6c6;
box-shadow: rgba(0, 0, 0, 0.4) 1px 2px 5px;
z-index: 2000;
height: 100px;
width: 200px;
}
.loginBoxLabel {
display: inline-block;
width: 200px;
text-align: center;
}
</style>
<!DOCTYPE html>
<html lang="en" style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/ja/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/ja/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script src="$DEMOROOT$/spread/source/data/sorting.js" type="text/javascript"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/ja/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

menuDataプロパティを、次のように定義できます。
カスタムメニューオプションを追加または削除するには、spread.contextMenu.menuDataプロパティを使用します。
import { Component, NgModule, enableProdMode } from '@angular/core';
import { bootstrapApplication, BrowserModule } from '@angular/platform-browser';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import './styles.css';
const spreadNS = GC.Spread.Sheets, SheetArea = spreadNS.SheetArea;
function showLoginDialog() {
if (document.getElementsByClassName('loginBox').length === 0) {
let loginBox = document.createElement('div');
loginBox.className = 'loginBox';
loginBox.innerHTML = '<label for="Dialog" class="loginBoxLabel">Dialog:</label>' +
'<input type="button" id="okBtn" class="btn-primary button" value="OK">' +
'<input type="button" id="cancelBtn" class="btn-primary button" value="Cancel">';
document.body.appendChild(loginBox);
document.getElementById('okBtn').onclick = function (){
loginBox.style.display = 'none';
};
document.getElementById('cancelBtn').onclick = function (){
loginBox.style.display = 'none';
};
}
let loginBoxEle = document.getElementsByClassName('loginBox')[0];
if (loginBoxEle.style.display === 'none') {
loginBoxEle.style.display = 'block';
}
}
@Component({
standalone: true,
imports: [SpreadSheetsModule, BrowserModule, FormsModule],
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor () {
}
initSpread ($event: any) {
this.spread = $event.spread;
}
addFormatCell() {
let spread = this.spread;
let commandRemoved = false;
spread.contextMenu.menuData.forEach(function (item, index) {
if (item && item.name === "markWithRedBg") {
spread.contextMenu.menuData.splice(index, 1);
commandRemoved = true;
}
});
if (commandRemoved) {
return;
}
let commandManager = spread.commandManager();
let markWithRedBg = {
text: "Format Cells",
name: "markWithRedBg",
command: "markWithRedBg",
workArea: "viewport"
};
spread.contextMenu.menuData.push(markWithRedBg);
let markWithRedBgCommand = {
canUndo: false,
execute: function () {
let style = new GC.Spread.Sheets.Style();
style.name = 'style1';
style.backColor = 'red';
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
let selections = sheet.getSelections();
let selectionIndex = 0, selectionCount = selections.length;
for (; selectionIndex < selectionCount; selectionIndex++) {
let selection = selections[selectionIndex];
for (let i = selection.row; i < (selection.row + selection.rowCount); i++) {
for (let j = selection.col; j < (selection.col + selection.colCount); j++) {
sheet.setStyle(i, j, style, GC.Spread.Sheets.SheetArea.viewport);
}
}
}
sheet.resumePaint();
}
};
commandManager.register("markWithRedBg", markWithRedBgCommand, null, false, false, false, false);
}
addOpenDialog() {
let spread = this.spread;
let commandRemoved = false;
spread.contextMenu.menuData.forEach(function (item, index) {
if (item && item.name === "openDialog") {
spread.contextMenu.menuData.splice(index, 1);
commandRemoved = true;
}
});
if (commandRemoved) {
return;
}
let openDialog = {
text: "Open Dialog",
name: "openDialog",
command: showLoginDialog,
workArea: "viewport"
};
spread.contextMenu.menuData.push(openDialog);
}
}
enableProdMode();
bootstrapApplication(AppComponent);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/ja/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/ja/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/ja/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/ja/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="options-row">
<p>任意のセルを右クリックすると、固有のコンテキストメニューが表示されます。このコンテキストメニューに対し、以下のいずれかのオプションを追加または削除できます。</p>
</div>
<div class="options-row">
<input type="checkbox" id="addFormatCell" (change)="addFormatCell()">
<label for="addFormatCell">[セルの書式設定]メニュー項目を追加する</label>
</div>
<div class="options-row">
<input type="checkbox" id="addOpenDialog" (change)="addOpenDialog()">
<label for="addOpenDialog">[ダイアログを開く]メニュー項目を追加する</label>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
p{
padding:2px 10px;
background-color:#F4F8EB;
}
input {
display: inline-block;
}
input[type="text"] {
width: 200px;
}
input[type=button] {
margin-top: 6px;
}
label {
margin-bottom: 6px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.loginBox {
position: absolute;
left: 35%;
top: 30%;
background-color: white;
padding: 20px;
border: 1px solid #c6c6c6;
box-shadow: rgba(0, 0, 0, 0.4) 1px 2px 5px;
z-index: 2000;
height: 100px;
width: 200px;
}
.loginBoxLabel {
display: inline-block;
width: 200px;
text-align: center;
}
.button{
width: 30%;
margin: 60px 10%;
text-align: center;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'tslib':'npm:tslib/tslib.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts',
meta: {
"*.component.ts": {
loader: "system.component-loader.js"
}
}
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

menuDataプロパティを、次のように定義できます。
カスタムメニューオプションを追加または削除するには、spread.contextMenu.menuDataプロパティを使用します。
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import './styles.css';
const useState = React.useState;
export function AppFunc() {
const [spread, setSpread] = useState(null);
const initSpread = (spread) => {
setSpread(spread);
}
const addFormatCell = () => {
let commandRemoved = false;
spread.contextMenu.menuData.forEach(function (item, index) {
if (item && item.name === "markWithRedBg") {
spread.contextMenu.menuData.splice(index, 1);
commandRemoved = true;
}
});
if (commandRemoved) {
return;
}
let commandManager = spread.commandManager();
let markWithRedBg = {
text: "Format Cells",
name: "markWithRedBg",
command: "markWithRedBg",
workArea: "viewport"
};
spread.contextMenu.menuData.push(markWithRedBg);
let markWithRedBgCommand = {
canUndo: false,
execute: function () {
let style = new GC.Spread.Sheets.Style();
style.name = 'style1';
style.backColor = 'red';
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
let selections = sheet.getSelections();
let selectionIndex = 0, selectionCount = selections.length;
for (; selectionIndex < selectionCount; selectionIndex++) {
let selection = selections[selectionIndex];
for (let i = selection.row; i < (selection.row + selection.rowCount); i++) {
for (let j = selection.col; j < (selection.col + selection.colCount); j++) {
sheet.setStyle(i, j, style, GC.Spread.Sheets.SheetArea.viewport);
}
}
}
sheet.resumePaint();
}
};
commandManager.register("markWithRedBg", markWithRedBgCommand, null, false, false, false, false);
}
const addOpenDialog = () => {
let commandRemoved = false;
spread.contextMenu.menuData.forEach(function (item, index) {
if (item && item.name === "openDialog") {
spread.contextMenu.menuData.splice(index, 1);
commandRemoved = true;
}
});
if (commandRemoved) {
return;
}
let openDialog = {
text: "Open Dialog",
name: "openDialog",
command: showLoginDialog,
workArea: "viewport"
};
spread.contextMenu.menuData.push(openDialog);
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
addFormatCell={() => addFormatCell()}
addOpenDialog={() => addOpenDialog()}
></Panel>
</div>
);
}
function showLoginDialog() {
if (document.getElementsByClassName('loginBox').length === 0) {
var loginBox = document.createElement('div');
loginBox.className = 'loginBox';
loginBox.innerHTML = '<label for="Dialog" class="loginBoxLabel">Dialog:</label>' +
'<input type="button" id="okBtn" class="btn-primary button" value="OK">' +
'<input type="button" id="cancelBtn" class="btn-primary button" value="Cancel">';
document.body.appendChild(loginBox);
document.getElementById('okBtn').onclick = function () {
loginBox.style.display = 'none';
};
document.getElementById('cancelBtn').onclick = function () {
loginBox.style.display = 'none';
};
}
var loginBoxEle = document.getElementsByClassName('loginBox')[0];
if (loginBoxEle.style.display === 'none') {
loginBoxEle.style.display = 'block';
}
}
function CheckBoxInput(props) {
const [checked, setChecked] = useState(props.checked);
return (
<input type="checkbox" id={props.id} checked={checked} onChange={(e) => {
setChecked(e.target.checked);
props.onChange(e)
}} />
);
}
function Panel(props) {
return (
<div class="options-container">
<div className="option-row">
<p>任意のセルを右クリックすると、固有のコンテキストメニューが表示されます。このコンテキストメニューに対し、以下のいずれかのオプションを追加または削除できます。</p>
</div>
<div className="option-row">
<CheckBoxInput id="addFormatCell" checked={false} onChange={props.addFormatCell}></CheckBoxInput>
<label htmlFor="addFormatCell">[セルの書式設定]メニュー項目を追加する</label>
</div>
<div className="option-row">
<CheckBoxInput id="addOpenDialog" checked={false} onChange={props.addOpenDialog}></CheckBoxInput>
<label htmlFor="addOpenDialog">[ダイアログを開く]メニュー項目を追加する</label>
</div>
</div>
);
}
import * as React from 'react';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import './styles.css';
const Component = React.Component, useState = React.useState;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet>
</Worksheet>
</SpreadSheets>
</div>
<Panel
addFormatCell={() => this.addFormatCell()}
addOpenDialog={() => this.addOpenDialog()}
></Panel>
</div>
);
}
initSpread(spread) {
this.spread = spread;
}
addFormatCell() {
let spread = this.spread;
let commandRemoved = false;
spread.contextMenu.menuData.forEach(function (item, index) {
if (item && item.name === "markWithRedBg") {
spread.contextMenu.menuData.splice(index, 1);
commandRemoved = true;
}
});
if (commandRemoved) {
return;
}
let commandManager = spread.commandManager();
let markWithRedBg = {
text: "Format Cells",
name: "markWithRedBg",
command: "markWithRedBg",
workArea: "viewport"
};
spread.contextMenu.menuData.push(markWithRedBg);
let markWithRedBgCommand = {
canUndo: false,
execute: function () {
let style = new GC.Spread.Sheets.Style();
style.name = 'style1';
style.backColor = 'red';
let sheet = spread.getActiveSheet();
sheet.suspendPaint();
let selections = sheet.getSelections();
let selectionIndex = 0, selectionCount = selections.length;
for (; selectionIndex < selectionCount; selectionIndex++) {
let selection = selections[selectionIndex];
for (let i = selection.row; i < (selection.row + selection.rowCount); i++) {
for (let j = selection.col; j < (selection.col + selection.colCount); j++) {
sheet.setStyle(i, j, style, GC.Spread.Sheets.SheetArea.viewport);
}
}
}
sheet.resumePaint();
}
};
commandManager.register("markWithRedBg", markWithRedBgCommand, null, false, false, false, false);
}
addOpenDialog() {
let spread = this.spread;
let commandRemoved = false;
spread.contextMenu.menuData.forEach(function (item, index) {
if (item && item.name === "openDialog") {
spread.contextMenu.menuData.splice(index, 1);
commandRemoved = true;
}
});
if (commandRemoved) {
return;
}
let openDialog = {
text: "Open Dialog",
name: "openDialog",
command: showLoginDialog,
workArea: "viewport"
};
spread.contextMenu.menuData.push(openDialog);
}
}
function showLoginDialog() {
if (document.getElementsByClassName('loginBox').length === 0) {
var loginBox = document.createElement('div');
loginBox.className = 'loginBox';
loginBox.innerHTML = '<label for="Dialog" class="loginBoxLabel">Dialog:</label>' +
'<input type="button" id="okBtn" class="btn-primary button" value="OK">' +
'<input type="button" id="cancelBtn" class="btn-primary button" value="Cancel">';
document.body.appendChild(loginBox);
document.getElementById('okBtn').onclick = function () {
loginBox.style.display = 'none';
};
document.getElementById('cancelBtn').onclick = function () {
loginBox.style.display = 'none';
};
}
var loginBoxEle = document.getElementsByClassName('loginBox')[0];
if (loginBoxEle.style.display === 'none') {
loginBoxEle.style.display = 'block';
}
}
function CheckBoxInput(props) {
const [checked, setChecked] = useState(props.checked);
return (
<input type="checkbox" id={props.id} checked={checked} onChange={(e) => {
setChecked(e.target.checked);
props.onChange(e)
}} />
);
}
function Panel(props) {
return (
<div class="options-container">
<div className="option-row">
<p>任意のセルを右クリックすると、固有のコンテキストメニューが表示されます。このコンテキストメニューに対し、以下のいずれかのオプションを追加または削除できます。</p>
</div>
<div className="option-row">
<CheckBoxInput id="addFormatCell" checked={false} onChange={props.addFormatCell}></CheckBoxInput>
<label htmlFor="addFormatCell">[セルの書式設定]メニュー項目を追加する</label>
</div>
<div className="option-row">
<CheckBoxInput id="addOpenDialog" checked={false} onChange={props.addOpenDialog}></CheckBoxInput>
<label htmlFor="addOpenDialog">[ダイアログを開く]メニュー項目を追加する</label>
</div>
</div>
);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/ja/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/ja/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
input {
padding: 4px 6px;
}
label {
margin-bottom: 6px;
}
.buttonStyle{
width:240px;
height:30px;
}
.loginBox {
position: absolute;
left: 35%;
top: 30%;
background-color: white;
padding: 20px;
border: 1px solid #c6c6c6;
box-shadow: rgba(0, 0, 0, 0.4) 1px 2px 5px;
z-index: 2000;
height: 100px;
width: 200px;
}
.loginBoxLabel {
display: inline-block;
width: 200px;
text-align: center;
}
.button{
width: 30%;
margin: 60px 10%;
text-align: center;
}
p{
padding:2px 10px;
background-color:#F4F8EB;
}
input[type=button] {
margin-top: 6px;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
.loginBox {
position: absolute;
left: 35%;
top: 30%;
background-color: white;
padding: 20px;
border: 1px solid #c6c6c6;
box-shadow: rgba(0, 0, 0, 0.4) 1px 2px 5px;
z-index: 2000;
height: 100px;
width: 200px;
}
.loginBoxLabel {
display: inline-block;
width: 200px;
text-align: center;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);